package com.benyun.core.entity.vo;

import com.benyun.core.constant.ChannelMapContant;
import com.benyun.core.utils.HashUtil;
import com.benyun.core.valida.TopologicalWdGroup;
import com.benyun.core.valida.TopologicalWdListGroup;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

@Data
public class TopologicalWdAceeptVo {

    @NotBlank(groups = {TopologicalWdGroup.class,TopologicalWdListGroup.class},message = "请选择中心点")
    String centerWdId;
    @NotNull(groups = {TopologicalWdGroup.class,TopologicalWdListGroup.class},message = "半径范围未正确选择")
    int radius;
    int size = 10;

    @NotBlank(groups = {TopologicalWdListGroup.class},message = "geoHash不能为空")
    String geoHash;

    @NotNull(groups = {TopologicalWdListGroup.class},message = "lat不能为空")
    double lat;
    @NotNull(groups = {TopologicalWdListGroup.class},message = "lng不能为空")
    double lng;

    String[] channel;


    public String getHash(){
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(centerWdId);
        stringBuilder.append(radius);
        stringBuilder.append(size);
        stringBuilder.append(geoHash);
        stringBuilder.append(lat);
        stringBuilder.append(lng);
        for (String s : getChannel()) {
            stringBuilder.append(s);
        }


        String s = stringBuilder.toString();
        String md5 = HashUtil.hash(s, "MD5");
        return md5;
    }

    public String[] getChannel() {
        if(this.channel == null || this.channel.length == 0){
            return channel = ChannelMapContant.FULL_CHANNEL;
        }
        return channel;
    }

}
