package com.benyun.core.job;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.benyun.core.dao.WdInfoDao;
import com.benyun.core.entity.WdInfo;
import com.benyun.core.service.AnalyseWdService;
import lombok.extern.slf4j.Slf4j;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Arrays;
import java.util.List;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Slf4j
@Component
public class AnalyseJob implements Job {

    @Autowired
    AnalyseWdService analyseWdService;

    public static ExecutorService executor = Executors.newFixedThreadPool(10);

    @Autowired
    WdInfoDao wdInfoDao;

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        ZoneId zone = ZoneId.of("Asia/Shanghai");
        LocalDateTime now = LocalDateTime.now(zone);  //分析时间

        System.out.println("start:");

        //测试需要
        QueryWrapper<WdInfo> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.in("wd_type_code", Arrays.asList("1","2","3"));

        List<WdInfo> wdInfos1 = wdInfoDao.selectList(queryWrapper1);
        int index = 1;
        System.out.println(wdInfos1.size());
        //1.遍历所有网点
        for (WdInfo wdInfo : wdInfos1) {
            analyseWdService.analyse(wdInfo,now,wdInfos1.size(),index++);
        }
    }
}
