package com.benyun.core.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.benyun.core.dao.BrandMapper;
import com.benyun.core.dao.WdInfoDao;
import com.benyun.core.dao.WdTopologicalInfoDao;
import com.benyun.core.entity.*;
import com.benyun.core.entity.vo.ChannelAnalyseAceeptVo;
import com.benyun.core.entity.vo.ChannelMapAceeptVo;
import com.benyun.core.entity.vo.TagAnalyse;
import com.benyun.core.service.ChannelAnalyseService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.origin.Origin;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;

@Service
public class ChannelAnalyseServiceImpl implements ChannelAnalyseService {

    @Autowired
    WdInfoDao wdInfoDao;

    @Autowired
    @Qualifier("cityTierMap")
    HashMap<String, String> cityTierMap;

    @Autowired
    BrandMapper brandMapper;

    @Autowired
    WdTopologicalInfoDao wdTopologicalInfoDao;

    @Autowired
    @Qualifier("typeByMap")
    private HashMap<String, String> typeByMap;

    @Override
    public HashMap cityTier(ChannelAnalyseAceeptVo channelAnalyseAceeptVo) {
        HashMap<String, Long> result = new HashMap<>();
        result.put("一线", 0L);
        result.put("新一线", 0L);
        result.put("二线", 0L);
        result.put("三线", 0L);
        result.put("四线", 0L);
        result.put("五线", 0L);
        result.put("其他", 0L);

        //1.获取所有符合条件的网点信息
        QueryWrapper<WdInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.in("wd_type_code", channelAnalyseAceeptVo.getChannel());
        if (channelAnalyseAceeptVo.getSearchText() != null && !channelAnalyseAceeptVo.getSearchText().equals("")) {
            queryWrapper.and(wdInfoQueryWrapper -> {
                wdInfoQueryWrapper.like("wd_name", channelAnalyseAceeptVo.getSearchText());
            });
        }

        List<WdInfo> wdInfos = wdInfoDao.selectList(queryWrapper);
        System.out.println(wdInfos.size());
        for (WdInfo wdInfo : wdInfos) {
            String addrCode = wdInfo.getAddrCode();
            if (cityTierMap.containsKey(addrCode)) {
                result.put(cityTierMap.get(addrCode), result.get(cityTierMap.get(addrCode)) + 1);
            } else if (cityTierMap.containsKey(addrCode.substring(0, 4))) {
                result.put(cityTierMap.get(addrCode.substring(0, 4)), result.get(cityTierMap.get(addrCode.substring(0, 4))) + 1);
            } else if (cityTierMap.containsKey(addrCode.substring(0, 2))) {
                result.put(cityTierMap.get(addrCode.substring(0, 2)), result.get(cityTierMap.get(addrCode.substring(0, 2))) + 1);
            } else
                result.put("其他", result.get("其他") + 1);
        }


        return result;
    }

    @Override
    public PageInfo<Brand> brandList(ChannelAnalyseAceeptVo channelAnalyseAceeptVo) {
        PageHelper.startPage(channelAnalyseAceeptVo.getPageNum(), channelAnalyseAceeptVo.getPageSize());
        String text = "";
        if (channelAnalyseAceeptVo.getSearchText() != null)
            text = channelAnalyseAceeptVo.getSearchText();
        List<Brand> brands = brandMapper.searchList(text);
        PageInfo<Brand> pageInfo = new PageInfo<>(brands);
        return pageInfo;
    }

    //    @Override
//    public HashMap<String,Object> tagAnalyse(ChannelMapAceeptVo channelMapAceeptVo) {
//        //1.根据不同级别得到地区码
//        List<String> addrCodeList = new ArrayList<>();
//        if ("province".equals(channelMapAceeptVo.getRankType())) {
//            //省码
//            for (String s : channelMapAceeptVo.getAddrCode()) {
//                String substring = s.substring(0, 2);
//                addrCodeList.add(substring);
//            }
//        } else if ("city".equals(channelMapAceeptVo.getRankType())) {
//            //省的所有市
//            for (String s : channelMapAceeptVo.getAddrCode()) {
//                String substring = s.substring(0, 4);
//                addrCodeList.add(substring);
//            }
//        } else if ("zone".equals(channelMapAceeptVo.getRankType())) {
//            //区
//            for (String s : channelMapAceeptVo.getAddrCode()) {
//                String substring = s.substring(0, 6);
//                addrCodeList.add(substring);
//            }
//        } else {
//            return null;
//        }
//
//
//        //2.根据地区前缀找到所有的网点
//        QueryWrapper<WdTopologicalInfo> queryWrapper = new QueryWrapper<>();
//        queryWrapper.in("center_wd_type_code", channelMapAceeptVo.getChannel()).and(originWdInfoQueryWrapper -> {
//            for (String s : addrCodeList) {
//                originWdInfoQueryWrapper.likeRight("addr_code", s).or();
//            }
//        });
//
//        if (channelMapAceeptVo.getSearchText() != null && !channelMapAceeptVo.getSearchText().trim().equals("")) {
//            queryWrapper.and(originWdInfoQueryWrapper -> {
//                originWdInfoQueryWrapper.like("center_wd_name", channelMapAceeptVo.getSearchText());
//            });
//        }
//
//        queryWrapper.and(wdTopologicalInfoQueryWrapper -> {
//            wdTopologicalInfoQueryWrapper.eq("radius",1000); //1km内算附近
//        });
//        List<WdTopologicalInfo> originWdInfos = wdTopologicalInfoDao.selectList(queryWrapper);
//
//        //统计
//        Integer total = 0 ;
//        HashMap<String,Integer> hashMap = new HashMap<>();
//        for (WdTopologicalInfo originWdInfo : originWdInfos) {
//            String tag = originWdInfo.getTag();
//            for (String s : tag.split(";")) {
//                String[] split = s.split(":");
//                if (split != null && split.length == 2) {
//                    if(typeByMap.get(split[0]) == null)
//                        continue;
//                    String[] split1 = typeByMap.get(split[0]).split(":");
//                    String t = "";
//                    if (split1.length == 3)
//                        t = split1[2];
//                    else if (split1.length == 2)
//                        t = split1[1];
//                    else if (split1.length == 1)
//                        t = split1[0];
//
//                    if(!t.equals("")) {
//                        Integer integer = hashMap.get(t);
//                        if(integer == null)
//                            hashMap.put(t,1);
//                        else {
//                            hashMap.put(t,hashMap.get(t)+1);
//                        }
//                        total++;
//                    }
//                }
//            }
//        }
//        HashMap<String, Object> result = new HashMap<>();
//        List<TagAnalyse> list = new ArrayList<>();
//        for (String s : hashMap.keySet()) {
//            TagAnalyse tagAnalyse = new TagAnalyse();
//            tagAnalyse.setName(s);
//            tagAnalyse.setCount(hashMap.get(s));
//            tagAnalyse.setRadio((double)tagAnalyse.getCount()/total);
//            list.add(tagAnalyse);
//        }
//
//        Collections.sort(list, new Comparator<TagAnalyse>() {
//            @Override
//            public int compare(TagAnalyse o1, TagAnalyse o2) {
//                return o2.getCount() - o1.getCount();
//            }
//        });
//
//        result.put("total",total);
//        result.put("data",list);
//        return result;
//    }

    @Override
    public HashMap<String, Object> tagAnalyse(ChannelMapAceeptVo channelMapAceeptVo) {
        //1.根据不同级别得到地区码
        List<String> addrCodeList = new ArrayList<>();
        if ("province".equals(channelMapAceeptVo.getRankType())) {
            //省码
            for (String s : channelMapAceeptVo.getAddrCode()) {
                String substring = s.substring(0, 2);
                addrCodeList.add(substring);
            }
        } else if ("city".equals(channelMapAceeptVo.getRankType())) {
            //省的所有市
            for (String s : channelMapAceeptVo.getAddrCode()) {
                String substring = s.substring(0, 4);
                addrCodeList.add(substring);
            }
        } else if ("zone".equals(channelMapAceeptVo.getRankType())) {
            //区
            for (String s : channelMapAceeptVo.getAddrCode()) {
                String substring = s.substring(0, 6);
                addrCodeList.add(substring);
            }
        } else {
            return null;
        }


        //2.根据地区前缀找到所有的网点
        QueryWrapper<WdTopologicalInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.in("center_wd_type_code", channelMapAceeptVo.getChannel()).and(originWdInfoQueryWrapper -> {
            for (String s : addrCodeList) {
                originWdInfoQueryWrapper.likeRight("addr_code", s).or();
            }
        });

        if (channelMapAceeptVo.getSearchText() != null && !channelMapAceeptVo.getSearchText().trim().equals("")) {
            queryWrapper.and(originWdInfoQueryWrapper -> {
                originWdInfoQueryWrapper.like("center_wd_name", channelMapAceeptVo.getSearchText());
            });
        }

        queryWrapper.and(wdTopologicalInfoQueryWrapper -> {
            wdTopologicalInfoQueryWrapper.eq("radius",1000); //1km内算附近
        });
        List<WdTopologicalInfo> originWdInfos = wdTopologicalInfoDao.selectList(queryWrapper);

        //统计
        Integer total = originWdInfos.size() ;
        HashMap<String,Integer> hashMap = new HashMap<>();
        for (WdTopologicalInfo originWdInfo : originWdInfos) {
            String tag = originWdInfo.getTag();
            for (String s : tag.split(";")) {
                String[] split = s.split(":");
                if (split != null && split.length == 2) {
                    if(typeByMap.get(split[0]) == null)
                        continue;
                    String[] split1 = typeByMap.get(split[0]).split(":");
                    String t = "";
                    if (split1.length == 3)
                        t = split1[2];
                    else if (split1.length == 2)
                        t = split1[1];
                    else if (split1.length == 1)
                        t = split1[0];

                    if(!t.equals("")) {
                        Integer integer = hashMap.get(t);
                        if(integer == null)
                            hashMap.put(t,1);
                        else {
                            hashMap.put(t,hashMap.get(t)+1);
                        }
                    }
                }
            }
        }
        HashMap<String, Object> result = new HashMap<>();
        List<TagAnalyse> list = new ArrayList<>();
        for (String s : hashMap.keySet()) {
            TagAnalyse tagAnalyse = new TagAnalyse();
            tagAnalyse.setName(s);
            tagAnalyse.setCount(hashMap.get(s));
            BigDecimal bigDecimal = new BigDecimal((double) tagAnalyse.getCount() / total);
            double v = bigDecimal.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
            tagAnalyse.setRadio(v);
            list.add(tagAnalyse);
        }

        Collections.sort(list, new Comparator<TagAnalyse>() {
            @Override
            public int compare(TagAnalyse o1, TagAnalyse o2) {
                return o2.getCount() - o1.getCount();
            }
        });


        int i = 1;
        int start = 0,end = 6;
        while(start<list.size()){
            if(end>=list.size())
                end = list.size();
            result.put(""+i++,new ArrayList(list.subList(start,end)));
            start=end;
            end+=6;
        }
        result.put("pages",i-1);
        result.put("total",total);
        return result;
    }

    @Override
    public void businessAnalyse(ChannelMapAceeptVo channelMapAceeptVo) {
        //1.根据不同级别得到地区码
        List<String> addrCodeList = new ArrayList<>();
        if ("province".equals(channelMapAceeptVo.getRankType())) {
            //省码
            for (String s : channelMapAceeptVo.getAddrCode()) {
                String substring = s.substring(0, 2);
                addrCodeList.add(substring);
            }
        } else if ("city".equals(channelMapAceeptVo.getRankType())) {
            //省的所有市
            for (String s : channelMapAceeptVo.getAddrCode()) {
                String substring = s.substring(0, 4);
                addrCodeList.add(substring);
            }
        } else if ("zone".equals(channelMapAceeptVo.getRankType())) {
            //区
            for (String s : channelMapAceeptVo.getAddrCode()) {
                String substring = s.substring(0, 6);
                addrCodeList.add(substring);
            }
        } else {
            //return null;
        }


        //2.根据地区前缀找到所有的网点
        QueryWrapper<WdTopologicalInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.select("wd_id");
        queryWrapper.in("wd_type_code", channelMapAceeptVo.getChannel()).and(originWdInfoQueryWrapper -> {
            for (String s : addrCodeList) {
                originWdInfoQueryWrapper.likeRight("addr_code", s).or();
            }
        });

        if (channelMapAceeptVo.getSearchText() != null && !channelMapAceeptVo.getSearchText().trim().equals("")) {
            queryWrapper.and(originWdInfoQueryWrapper -> {
                originWdInfoQueryWrapper.like("wd_name", channelMapAceeptVo.getSearchText());
            });
        }
    }
}
