package com.benyun.core.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.benyun.core.dao.WdInfoDao;
import com.benyun.core.entity.TopologicalStoreWd;
import com.benyun.core.entity.WdInfo;
import com.benyun.core.entity.vo.TopologicalWdAceeptVo;
import com.benyun.core.service.TopologicalCommonService;
import com.benyun.core.utils.DistanceUtil;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.gavaghan.geodesy.Ellipsoid;
import org.gavaghan.geodesy.GlobalCoordinates;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.lang.reflect.Array;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Service
public class TopologicalCommonServiceImpl implements TopologicalCommonService {
    @Autowired
    WdInfoDao wdInfoDao;

    @Override
    public List<WdInfo> prefixSearch(String searchText) {
        QueryWrapper<WdInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.likeRight("wd_name",searchText);
        queryWrapper.and(wdInfoQueryWrapper -> {
            wdInfoQueryWrapper.in("wd_type_code", Arrays.asList("1","2","3","5"));
        });

        PageHelper.startPage(1,8);
        List<WdInfo> wdInfos = wdInfoDao.selectList(queryWrapper);
        PageInfo<WdInfo> pageInfo = new PageInfo<>(wdInfos);
        return pageInfo.getList();
    }

    @Override
    public void search(String searchText, int radius) {

    }

//    @Override
//    public List<WdInfo> map(TopologicalWdAceeptVo topologicalWdAceeptVo) {
//        QueryWrapper<WdInfo> queryWrapper = new QueryWrapper<>();
//
//        //条件构造
//        queryWrapper.in("wd_type_code",topologicalWdAceeptVo.getChannel());
//        queryWrapper.and(wdInfoQueryWrapper -> {
//            wdInfoQueryWrapper.likeRight("geo_hash",topologicalWdAceeptVo.getGeoHash().substring(0,5));
//        });
//
//        //查询结果
//        List<WdInfo> wdInfos = wdInfoDao.selectList(queryWrapper);
//
//        List<WdInfo> list = new ArrayList<>();  //返回结果集
//        GlobalCoordinates source = new GlobalCoordinates(topologicalWdAceeptVo.getLat(), topologicalWdAceeptVo.getLng());
//        for (WdInfo wdInfo : wdInfos) {
//            //1.计算距离
//            GlobalCoordinates target = new GlobalCoordinates(wdInfo.getLat().doubleValue(), wdInfo.getLng().doubleValue());
//            double meter2 = DistanceUtil.getDistanceMeter(source, target, Ellipsoid.WGS84);
//
//            if(meter2 <= topologicalWdAceeptVo.getRadius()){
//                list.add(wdInfo);
//            }
//        }
//        return list;
//    }

    @Override
    public List<WdInfo> map(TopologicalWdAceeptVo topologicalWdAceeptVo) {
        QueryWrapper<WdInfo> queryWrapper = new QueryWrapper<>();

        //条件构造
        queryWrapper.in("wd_type_code",topologicalWdAceeptVo.getChannel());
        queryWrapper.and(wdInfoQueryWrapper -> {
            wdInfoQueryWrapper.likeRight("geo_hash",topologicalWdAceeptVo.getGeoHash().substring(0,5));
        });

        //查询结果
        List<WdInfo> wdInfos = wdInfoDao.selectList(queryWrapper);

        List<WdInfo> list = new ArrayList<>();  //返回结果集
        GlobalCoordinates source = new GlobalCoordinates(topologicalWdAceeptVo.getLat(), topologicalWdAceeptVo.getLng());
        for (WdInfo wdInfo : wdInfos) {
            //1.计算距离
            GlobalCoordinates target = new GlobalCoordinates(wdInfo.getLat().doubleValue(), wdInfo.getLng().doubleValue());
            double meter2 = DistanceUtil.getDistanceMeter(source, target, Ellipsoid.WGS84);

            if(meter2 <= topologicalWdAceeptVo.getRadius()){
                list.add(wdInfo);
            }
        }
        return list;
    }

}
